unit MainFrm;

interface

uses
  Classes, Controls, Forms, StdCtrls, SysUtils, Windows, ExtDlgs, ExtCtrls,
  ComCtrls, Dialogs,
  { DCR Units }
  BackPropCls, GlobalMdl, DCRFra;

type
  TfrmMain = class(TForm)
    OpenPictureDialog: TOpenPictureDialog;
    DCR: TDCRFrame;
    StatusBar: TStatusBar;
    pnlResult: TPanel;
    edIndexNum1: TLabeledEdit;
    edIndexNum2: TLabeledEdit;
    btnReadCardValues: TButton;
    edCardValues: TLabeledEdit;
    pnlInfo: TPanel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnReadCardValuesClick(Sender: TObject);
    procedure DCRDblClick(Sender: TObject);
  private
    function ExePath: string;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

{==============================================================================}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  OpenPictureDialog.InitialDir := ExePath+'Extracted';
  BackProp := TBackProp.Create(DEFAULT_INPUT_PATTERN_HEIGHT,
                               DEFAULT_INPUT_PATTERN_WIDTH,
                               DEFAULT_TARGET_PATTERN_HEIGHT,
                               DEFAULT_TARGET_PATTERN_WIDTH,
                               DEFAULT_NUMBER_OF_HIDDEN_NEURON);
  BackProp.OpenKnowledge(ExePath+'twsOCR.ocr');
  DCR.Init;
end;

{------------------------------------------------------------------------------}

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BackProp.Free;
end;

{------------------------------------------------------------------------------}

function TfrmMain.ExePath: string;
begin
  Result := IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)));
end;

{------------------------------------------------------------------------------}

procedure TfrmMain.DCRDblClick(Sender: TObject);
var
  S: string;
  P: integer;
begin
  if OpenPictureDialog.Execute then begin
    DCR.OpenPicture(OpenPictureDialog.FileName);
    DCR.Recognize;
    S := DCR.ResultText;
    P := Pos(#32,S);
    if P = 0 then begin
      edIndexNum1.Text := 'Error';
      edIndexNum2.Text := 'Error';
    end else begin
      edIndexNum1.Text := Trim(Copy(S,1,P-1));
      edIndexNum2.Text := Trim(Copy(S,P+1,Length(S)));
    end;
  end;
end;

{------------------------------------------------------------------------------}

procedure TfrmMain.btnReadCardValuesClick(Sender: TObject);
var
  SL: TStringList;
  I1, I2: integer;
begin
  if not FileExists(ExePath+'twsOCR.dat') then begin
    edCardValues.Text := 'Error';
  end else begin
    SL := TStringList.Create;
    try
      { Add some checks here (SL.Count etc.) }
      SL.LoadFromFile(ExePath+'twsOCR.dat');
      I1 := StrToIntDef(edIndexNum1.Text,0);
      I2 := StrToIntDef(edIndexNum2.Text,0);
      edCardValues.Text := SL.Strings[I1]+SL.Strings[I2];
    finally
      SL.Free;
    end;
  end;
end;

{------------------------------------------------------------------------------}

end.
